

add_executable(test_tim.elf ${COMMENT_SOURCE_FILE} ${COMMENT_SOURCE_FILE} User/Test/test_tim.c)
target_include_directories(test_tim.elf PRIVATE User)
target_compile_options(test_tim.elf PRIVATE -Os)
target_sources(test_tim.elf PRIVATE 
    "User/system_ch32v20x.c"
    "User/tim.c"
)

set(HEX_FILE ${PROJECT_BINARY_DIR}/test_tim.hex)
set(BIN_FILE ${PROJECT_BINARY_DIR}/test_tim.bin)
set(LIST_FILE ${PROJECT_BINARY_DIR}/test_tim.list)

add_custom_command(TARGET test_tim.elf POST_BUILD
        COMMAND ${SIZE} --format=berkeley $<TARGET_FILE:test_tim.elf>
        COMMAND ${CMAKE_OBJDUMP} --all-headers --demangle --disassemble $<TARGET_FILE:test_tim.elf> > ${LIST_FILE}
        COMMAND ${CMAKE_OBJCOPY} -O ihex $<TARGET_FILE:test_tim.elf> ${HEX_FILE}
        COMMAND ${CMAKE_OBJCOPY} -O binary $<TARGET_FILE:test_tim.elf> ${BIN_FILE}
        COMMENT "Building ${HEX_FILE}
Building ${BIN_FILE}")