/*
 * @Author: xiaosenluo xiaosenluo@yandex.com
 * @Date: 2023-02-06 00:32:59
 * @LastEditors: xiaosenluo xiaosenluo@yandex.com
 * @LastEditTime: 2023-02-12 18:13:38
 * @FilePath: \wch_ch32v203_TeensyStepC\User\ch32v20x_it.c
 * @Description: 
 * 
 * Copyright (c) 2023 by ${git_name_email}, All Rights Reserved. 
 */
/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch32v20x_it.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main Interrupt Service Routines.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/
#include "ch32v20x_it.h"

// void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
// void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
  while (1)
  {
  }
}


#include "TeensyStepC.h"

extern StepControl stepControl;
extern RotateControl rotateControl;

extern void GPIO_Toggle(GPIO_TypeDef *GPIOx, uint16_t Pinx);

/**
 * @brief 使用硬件压栈, __attribute__((interrupt("WCH-Interrupt-fast")))
 *        使用软件压栈, __attribute__((interrupt()))
 */

void TIM2_IRQHandler(void){
    if(TIM_GetFlagStatus(TIM2, TIM_FLAG_Update) == SET){
        TIM_ClearFlag(TIM2, TIM_FLAG_Update);
        
#if(ALLOCAT_PULSE_TIMER)
        TIM_Cmd(TIM2, DISABLE);
        // GPIO_Toggle(GPIOA, GPIO_Pin_12);
        pulseTimerISR(&stepControl.controller);
        // GPIO_Toggle(GPIOA, GPIO_Pin_12);
#endif
    }
}

void TIM3_IRQHandler(void){
    if(TIM_GetFlagStatus(TIM3, TIM_FLAG_Update) == SET){
        TIM_ClearFlag(TIM3, TIM_FLAG_Update);
        GPIO_Toggle(GPIOA, GPIO_Pin_14);
        StepControl_accTimerISR(&stepControl);
        // RotateControl_accTimerISR(&rotateControl);
        GPIO_Toggle(GPIOA, GPIO_Pin_14);
    }
}

void TIM4_IRQHandler(void){
    if(TIM_GetFlagStatus(TIM4, TIM_FLAG_Update) == SET){
        TIM_ClearFlag(TIM4, TIM_FLAG_Update);
        GPIO_Toggle(GPIOB, GPIO_Pin_3);
        stepTimerISR(&stepControl.controller);
        GPIO_Toggle(GPIOB, GPIO_Pin_3);
        return;
    }
#if(ALLOCAT_PULSE_TIMER == 0)
    if(TIM_GetFlagStatus(TIM4, TIM_FLAG_CC1) == SET){
        TIM_ClearFlag(TIM4, TIM_FLAG_CC1);
        GPIO_Toggle(GPIOA, GPIO_Pin_12);
        pulseTimerISR(&stepControl.controller);
        GPIO_Toggle(GPIOA, GPIO_Pin_12);
    }
#endif
}


